;[SYSCONST]
MaxDAValue=1023				; Max Value on 10 bit DAC

;[EXTCOMM]
CompAction SOM(v:word)begin
 0x20,v
end

CompAction __DA1(v:word) begin
 0x11, v
end

CompAction __DA2(v:word) begin
 0x12, v
end

CompAction __DA3(v:word) begin
 0x13, v
end

CompAction __DA4(v:word) begin
 0x14, v
end

CompAction __Beep begin	
  0x50
end

CompAction __StartReg(v: byte) begin
 0xB0, v
end

CompAction __StopReg begin
 0xB1 
end

CompAction __SetTemp(v: int) begin
 0xB3, v
end

CompAction __SetRisTemp(v: int, z:word) begin
 0xB4, v, z 
end

CompAction __SetRegulator(v: byte, z:byte) begin
 0xB7, v, z 
end


CompAction __Shutter(v: byte) begin
 0x68, v
end

CompAction __Repeat(v:byte) begin
  0x70, v
end

CompAction __Average(v:byte) begin
  0x71, v
end

CompAction __Wait begin
  0x40
end

CompAction SP begin
 0x00
end


CompAction __Set_Freq(v:word, z: word) begin
 0xC5, v, z
end

CompAction __Set_Amplitude(v:byte) begin
 0xC6, v
end

CompAction __Set_Offset(v:byte) begin
 0xC7, v
end

CompAction __Set_Sweep(v:word, z:word, u:int) begin
 0xC8, v, z, u
end

CompAction __Freq_Start  begin
 0xC9
end

CompAction __Freq_Stop  begin
 0xC4
end

CompAction __Set_Phase(v:word) begin
 0xC3, v
end

CompAction __Gain(v:byte, u:byte) begin
 0xC0, v, u
end

CompAction __Offset(v:byte, u:byte) begin
 0xC1, v, u
end


;[EVENT]
PrimAction	EmptyAction(0x0,0x0,0)
PrimAction	m1(0x0001,0x10000001,2us)		; Bit 0
PrimAction	m2(0x0002,0x10000002,2us)		; Bit 1
PrimAction	m(0x0003,0x10000003,2us)		; Bit 2
PrimAction	m1ex(0x1000001,0x11000001,2us)		; Fast ADC (many samples)
PrimAction	m2ex(0x1000002,0x11000002,2us)		; Fast ADC (many samples)
PrimAction	F1(0x0008,0x10000008,ActinicFlash)	; Bit 3
PrimAction	F2(0x0010,0x10000010,ActinicFlash)	; Bit 4
PrimAction	f(0x0004,0x10000004,MeasuringFlash)	; f
PrimAction	extcomm(0x10000080,0x0080,60us)
PrimAction	msub(0x0063,0x10000063,2us)
PrimAction	m1sub(0x0021,0x10000021,2us)		; Bit 0 and sub from next
PrimAction	m2sub(0x0042,0x10000042,2us)		; Bit 1 and sub from next
PrimAction	Aux1(0x00100,0x10000100,AuxDuration)
PrimAction	A1(0x00100,0x10000100,AuxDuration)
PrimAction	Aux2(0x00200,0x10000200,AuxDuration)
PrimAction	A2(0x00200,0x10000200,AuxDuration)
PrimAction	Aux3(0x0400,0x10000400,AuxDuration)
PrimAction	A3(0x0400,0x10000400,AuxDuration)
PrimAction	Aux4(0x0800,0x10000800,AuxDuration)
PrimAction	A4(0x0800,0x10000800,AuxDuration)
PrimAction	Aux5(0x1000,0x10001000,AuxDuration)
PrimAction	A5(0x1000,0x10001000,AuxDuration)
PrimAction	Aux6(0x2000,0x10002000,AuxDuration)
PrimAction	A6(0x2000,0x10002000,AuxDuration)
PrimAction	Aux7(0x4000,0x10004000,AuxDuration)
PrimAction	A7(0x4000,0x10004000,AuxDuration)
PrimAction	Aux8(0x8000,0x10008000,AuxDuration)
PrimAction	A8(0x8000,0x10008000,AuxDuration)

PrimAction	mer1(0x0001,0x10000001,50us)		; Bit 0
PrimAction	mer2(0x0002,0x10000002,50us)		; Bit 1
PrimAction	mer1sub(0x0021,0x10000021,50us)		; Bit 0 and sub from next
PrimAction	mer2sub(0x0042,0x10000042,50us)		; Bit 1 and sub from next
PrimAction	Pr256C1(0x8001,0x10008001,4200us)
PrimAction	Pr256C2(0x8002,0x10008002,4200us)
PrimAction	Pr16C1(0x4001,0x10004001,300us)
PrimAction	Pr16C2(0x4002,0x10004002,300us)
PrimAction	BlikF1(0x0008,0x10000008,50us)		; Bit 3
PrimAction	BlikF2(0x0010,0x10000010,50us)		; Bit 4
PrimAction	Blikf(0x0004,0x10000004,100us)		; Bit 2

;ACTION
Action DA1(Value) begin
  <0>=>__DA1(Fit(0,MaxDAValue,Value*10)), extcomm
end

Action DA2(Value) begin
  <0>=>__DA2(Fit(0,MaxDAValue,Value*10)), extcomm
end

Action DA3(Value) begin
  <0>=>__DA3(Fit(0,MaxDAValue,Value*10)), extcomm
end

Action DA4(Value) begin
  <0>=>__DA4(Fit(0,MaxDAValue,Value*10)), extcomm
end


Action Set_Freq(Value1, Value2) begin
  <0>=>__Set_Freq(Value2, Value1), extcomm
end


Action Set_Offset(Value) begin
  <0>=>__Set_Offset(Fit(0,100,Value)), extcomm
end

Action Set_Amplitude(Value) begin
  <0>=>__Set_Amplitude(Fit(0,100,Value)), extcomm
end

Action Set_Sweep(Value1, Value2, Value3) begin
   <0>=>__Set_Sweep(Value2, Value1, Value3), extcomm
end

Action Freq_Start begin
    <0>=>__Freq_Start, extcomm
end

Action Freq_Stop begin
    <0>=>__Freq_Stop, extcomm
end

Action Set_Phase(Value) begin
  <0>=>__Set_Phase(Fit(0,359,Value)), extcomm
end


Action Repeat(Value) begin
  <0>=>__Repeat(Value), extcomm
end

Action Average(Value) begin
  <0>=>__Average(Value), extcomm
end

Action Wait begin
  <0>=>__Wait, extcomm
end



;Temperature regulation start
Action StartReg begin
 <0>=>__StartReg(1), extcomm
end

;Temperature regulation stop
Action StopReg begin
 <0>=>__StopReg, extcomm
end


;Set regulation temperature for TR2000
;parameter: 	- temperature in 1C (0-100)
Action SetTemp(Value) begin
  <0>=>__SetTemp(Value), extcomm
end



;Set parameters of rising mode for TR2000
;parameters: 	Value  - demanded regulation end temperature in 1C (0-100)
;		Value2 - time for reaching the temperature in sec (65535)	
Action SetRisTemp(Value, Value2) begin
  <0>=>__SetRisTemp(Value, Value2), extcomm
end


;Set Regulator constants
;parameters:    Value - Sum_term  
;		Value2 - Gain_term
Action SetRegulator(Value, Value2) begin
  <0>=>__SetRegulator(Value, Value2), extcomm
end

Action Gain1(Value) begin
 <0>=>__Gain(Fit(0,100,Value),1), extcomm
end

Action Gain2(Value) begin
 <0>=>__Gain(Fit(0,100,Value),2), extcomm
end

Action Offset1(Value) begin
 <0>=>__Offset(Fit(0,100,Value),1), extcomm
end

Action Offset2(Value) begin
 <0>=>__Offset(Fit(0,100,Value),2), extcomm
end

Action Shutter(Value) begin
  <0>=>__Shutter(Value), extcomm
end

Action Beep begin	
  <0>=>__Beep, extcomm
end

Action fm begin
 <0>=>f
 <MeasurDelay>=>m
end

Action mfm begin
 <0>=>m
 <PreFlash>=>f
 <PreFlash+MeasurDelay>=>m
end

Action mfmsub begin
 <0>=>msub
 <PreFlash>=>f
 <PreFlash+MeasurDelay>=>m
end

Action fm1 begin
 <0>=>f
 <MeasurDelay>=>m1
end;

Action fm2 begin
 <0>=>f
 <MeasurDelay>=>m2
end;

Action mfm1 begin
 <0>=>m1
 <PreFlash>=>f
 <PreFlash+MeasurDelay>=>m1
end;

Action mfm2 begin
 <0>=>m2
 <PreFlash>=>f
 <PreFlash+MeasurDelay>=>m2
end;

Action mfm1sub begin
 <0>=>m1sub
 <PreFlash>=>f
 <PreFlash+MeasurDelay>=>m1
end;

Action mfm2sub begin
 <0>=>m2sub
 <PreFlash>=>f
 <PreFlash+MeasurDelay>=>m2
end;

; sem nejak nepochopil
;<100ns>=>EmptyAction;