;[SYSCONST]
MaxDAValue=1023				; Max Value on 10 bit DAC
init = -1
sample_duration = 100ms
delayed_run = 0.675228s
Fast_sampling_CH1 = 0
Fast_sampling_CH2 = 0
A1_preillumination = 0
A2_preillumination = 0
FAR_duration = 0
Stirrer_disable = 1


;[EXTCOMM]
CompAction SOM(v:word)begin
 0x20,v
end

CompAction __DA1(v:word) begin
 0x11, v
end

CompAction __DA2(v:word) begin
 0x12, v
end

CompAction __DA3(v:word) begin
 0x13, v
end

CompAction __DA4(v:word) begin
 0x14, v
end

CompAction __DA5(v:word) begin
 0x15, v
end

CompAction __DA6(v:word) begin
 0x16, v
end

CompAction __DA7(v:word) begin
 0x17, v
end

CompAction __DA8(v:word) begin
 0x18, v
end

CompAction __Beep begin	
  0x50
end

CompAction __Freeze (v:word, u: byte) begin	
  0x52, v, u
end


CompAction __Shutter(v: byte) begin
 0x68, v
end

CompAction __Repeat(v:byte) begin
  0x70, v
end

CompAction __Average(v:byte) begin
  0x71, v
end

CompAction __Set_osc_light(v:byte) begin
  0x72, v
end

CompAction __Set_sweep_dir(v:byte) begin
  0x73, v
end

CompAction __Init_AUX(Event00:byte,Event0:byte,Time00:word,Time0:word) begin
  0x74, Event00,Event0,Time00,Time0
end

;maximal 10 variables in call-compiler restriction
CompAction __A1_Light10_Sequence(v1:word,v2:word,v3:word,v4:word,v5:word,v6:word,v7:word,v8:word,v9:word,v10:word) begin
  0x76, 0x0A, 0x02, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10
end

;maximal 10 variables in call - compiler restriction
CompAction __A2_Light10_Sequence(v1:word,v2:word,v3:word,v4:word,v5:word,v6:word,v7:word,v8:word,v9:word,v10:word) begin
  0x76, 0x0A, 0x04, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10
end



CompAction __Wait begin
  0x40
end

CompAction __Stirrer(t:byte) begin
  0x41, t
end

CompAction SP begin
 0x00
end

;Run more external commands in 1 time
CompAction __MultiCommand(v:byte) begin
 0x60,  v
end

;*******************************************************************************
;1 byte send via I2C on Channel
CompAction __ChanI2C_1(Channel:byte,Addr:byte,Data1:byte) begin
 0xA0, Channel, Addr,Data1 
end

;*******************************************************************************
;2 bytes send via I2C on Channel
CompAction __ChanI2C_2(Channel:byte,Addr:byte,Data1:byte,Data2:byte) begin
 0xA0, Channel, Addr,Data1,Data2 
end

;*******************************************************************************
;4 bytes send via I2C on Channel
CompAction __ChanI2C_3(Channel:byte,Addr:byte,Data1:byte,Data2:byte,Data3:byte) begin
 0xA0, Channel, Addr,Data1,Data2,Data3 
end

;*******************************************************************************
;5 bytes send via I2C on Channel
CompAction __ChanI2C_4(Channel:byte,Addr:byte,Data1:byte,Data2:byte,Data3:byte,Data4:byte) begin
 0xA0, Channel, Addr,Data1,Data2,Data3,Data4 
end


;*******************************************************************************
;1 byte send via I2C
CompAction __I2C_1(Addr:byte,Data1:byte) begin
 0xA1, Addr,Data1 
end

;*******************************************************************************

;2 bytes send via synchronous communication on I2C line
CompAction __SynCom_2(Reg:byte,Data1:byte,Data2:byte) begin
 0xA2, Reg,Data1,Data2 
end


;4 bytes send via synchronous communication on I2C line
CompAction __SynCom_4(Reg:byte,Data1:byte,Data2:byte,Data3:byte, Data4:byte) begin
 0xA2, Reg,Data1,Data2,Data3,Data4 
end

;6 bytes send via synchronous communication on I2C line
CompAction __SynCom_6(Reg:byte,Data1:byte,Data2:byte,Data3:byte,Data4:byte,Data5:byte,Data6:byte) begin
 0xA2, Reg,Data1,Data2,Data3,Data4,Data5,Data6 
end

;*******************************************************************************

;1 byte send via serial port
CompAction __Serial_1(Data1:byte) begin
 0xA3, Data1 
end


;*******************************************************************************

;(used in new oscillations)
;2 bytes send via synchronous communication on front connector
CompAction __SynCom_front_2(Channel:byte,Reg:byte,Data1:byte,Data2:byte) begin
 0xA4, Channel,Reg,Data1,Data2 
end


;4 bytes send via synchronous communication on front connector
CompAction __SynCom_front_4(Channel:byte,Reg:byte,Data1:byte,Data2:byte,Data3:byte, Data4:byte) begin
 0xA4, Channel,Reg,Data1,Data2,Data3,Data4 
end

;6 bytes send via synchronous communication on front connector
CompAction __SynCom_front_6(Channel:byte,Reg:byte,Data1:byte,Data2:byte,Data3:byte,Data4:byte,Data5:byte,Data6:byte) begin
 0xA4, Channel,Reg,Data1,Data2,Data3,Data4,Data5,Data6 
end

;*******************************************************************************

;[EVENT]
PrimAction	EmptyAction(0x0,0x0,0)
PrimAction	m1(0x0001,0x10000001,200ns)		; Bit 0
PrimAction	m2(0x0002,0x10000002,2us)		; Bit 1
PrimAction	m(0x0003,0x10000003,200ns)		; Bit 2
PrimAction	m1ex(0x1000001,0x11000001,200ns)		; Fast ADC (many samples)
PrimAction	m2ex(0x1000002,0x11000002,200ns)		; Fast ADC (many samples)
PrimAction	F1(0x0008,0x10000008,ActinicFlash)	; Bit 3
PrimAction	F2(0x0010,0x10000010,ActinicFlash)	; Bit 4
PrimAction	f(0x00004,0x10000004,MeasuringFlash)	; f
PrimAction	extcomm(0x10000080,0x0080,60us)
PrimAction	msub(0x0063,0x10000063,200ns)
PrimAction	m1sub(0x0021,0x10000021,200ns)		; Bit 0 and sub from next
PrimAction	m2sub(0x0042,0x10000042,200ns)		; Bit 1 and sub from next
PrimAction	Aux1(0x00100,0x10000100,AuxDuration)
PrimAction	A1(0x00100,0x10000100,AuxDuration)
PrimAction	Aux2(0x00200,0x10000200,AuxDuration)
PrimAction	A2(0x00200,0x10000200,AuxDuration)
PrimAction	Aux3(0x0400,0x10000400,AuxDuration)
PrimAction	A3(0x0400,0x10000400,AuxDuration)
PrimAction	Aux4(0x0800,0x10000800,AuxDuration)
PrimAction	A4(0x0800,0x10000800,AuxDuration)
PrimAction	Aux5(0x1000,0x10001000,AuxDuration)
PrimAction	A5(0x1000,0x10001000,AuxDuration)
PrimAction	Aux6(0x2000,0x10002000,AuxDuration)
PrimAction	A6(0x2000,0x10002000,AuxDuration)
PrimAction	Aux7(0x4000,0x10004000,AuxDuration)
PrimAction	A7(0x4000,0x10004000,AuxDuration)
PrimAction	Aux8(0x8000,0x10008000,AuxDuration)
PrimAction	A8(0x8000,0x10008000,AuxDuration)

PrimAction	mer1(0x0001,0x10000001,50us)		; Bit 0
PrimAction	mer2(0x0002,0x10000002,50us)		; Bit 1
PrimAction	mer1sub(0x0021,0x10000021,50us)		; Bit 0 and sub from next
PrimAction	mer2sub(0x0042,0x10000042,50us)		; Bit 1 and sub from next
PrimAction	Pr256C1(0x8001,0x10008001,4200us)
PrimAction	Pr256C2(0x8002,0x10008002,4200us)
PrimAction	Pr16C1(0x4001,0x10004001,300us)
PrimAction	Pr16C2(0x4002,0x10004002,300us)
PrimAction	BlikF1(0x0008,0x10000008,50us)		; Bit 3
PrimAction	BlikF2(0x0010,0x10000010,50us)		; Bit 4
PrimAction	Blikf(0x0004,0x10000004,100us)		; Bit 2

PrimAction	k1(0x0001,0x10000001,200ns)		; Bit 0

;ACTION
Action DA1(Value) begin
  <0>=>__DA1(Fit(0,MaxDAValue,Value*10)), extcomm
end

Action DA2(Value) begin
  <0>=>__DA2(Fit(0,MaxDAValue,Value*10)), extcomm
end

Action DA3(Value) begin
  <0>=>__DA3(Fit(0,MaxDAValue,Value*10)), extcomm
end

Action DA4(Value) begin
  <0>=>__DA4(Fit(0,MaxDAValue,Value*10)), extcomm
end

Action DA5(Value) begin
  <0>=>__DA5(Fit(0,MaxDAValue,Value*10)), extcomm
end

Action DA6(Value) begin
  <0>=>__DA6(Fit(0,MaxDAValue,Value*10)), extcomm
end

Action DA7(Value) begin
  <0>=>__DA7(Fit(0,MaxDAValue,Value*10)), extcomm
end

Action DA8(Value) begin
  <0>=>__DA8(Fit(0,MaxDAValue,Value*10)), extcomm
end



Action Repeat(Value) begin
  <0>=>__Repeat(Value), extcomm
end

Action Average(Value) begin
  <0>=>__Average(Value), extcomm
end

Action Wait begin
  <0>=>__Wait, extcomm
end

Action Shutter(Value) begin
  <0>=>__Shutter(Value), extcomm
end

Action Beep begin	
  <0>=>__Beep, extcomm
end


Action fm begin
 <0>=>f
 <MeasurDelay>=>m
end

Action mfm begin
 <0>=>m
 <PreFlash>=>f
 <PreFlash+MeasurDelay>=>m
end

Action mfmsub begin
 <0>=>msub
 <PreFlash>=>f
 <PreFlash+MeasurDelay>=>m
end

Action fm1 begin
 <0>=>f
 <MeasurDelay>=>m1
end;

Action fm2 begin
 <0>=>f
 <MeasurDelay>=>m2
end;

Action mfm1 begin
 <0>=>m1
 <PreFlash>=>f
 <PreFlash+MeasurDelay>=>m1
end;

Action mfm2 begin
 <0>=>m2
 <PreFlash>=>f
 <PreFlash+MeasurDelay>=>m2
end;

Action mfm1sub begin
 <0>=>m1sub
 <PreFlash>=>f
 <PreFlash+MeasurDelay>=>m1
end;

Action mfm2sub begin
 <0>=>m2sub
 <PreFlash>=>f
 <PreFlash+MeasurDelay>=>m2
end;


Action A1_Light10_Sequence(Value1,Value2,Value3,Value4,Value5,Value6,Value7,Value8,Value9,Value10) begin
<0>=>__A1_Light10_Sequence(Fit(0,MaxDAValue,Value1*MaxDAValue/100),Fit(0,MaxDAValue,Value2*MaxDAValue/100),Fit(0,MaxDAValue,Value3*MaxDAValue/100),Fit(0,MaxDAValue,Value4*MaxDAValue/100),Fit(0,MaxDAValue,Value5*MaxDAValue/100),Fit(0,MaxDAValue,Value6*MaxDAValue/100),Fit(0,MaxDAValue,Value7*MaxDAValue/100),Fit(0,MaxDAValue,Value8*MaxDAValue/100),Fit(0,MaxDAValue,Value9*MaxDAValue/100),Fit(0,MaxDAValue,Value10*MaxDAValue/100)), extcomm
end

Action A2_Light10_Sequence(Value1,Value2,Value3,Value4,Value5,Value6,Value7,Value8,Value9,Value10) begin
<0>=>__A2_Light10_Sequence(Fit(0,MaxDAValue,Value1*MaxDAValue/100),Fit(0,MaxDAValue,Value2*MaxDAValue/100),Fit(0,MaxDAValue,Value3*MaxDAValue/100),Fit(0,MaxDAValue,Value4*MaxDAValue/100),Fit(0,MaxDAValue,Value5*MaxDAValue/100),Fit(0,MaxDAValue,Value6*MaxDAValue/100),Fit(0,MaxDAValue,Value7*MaxDAValue/100),Fit(0,MaxDAValue,Value8*MaxDAValue/100),Fit(0,MaxDAValue,Value9*MaxDAValue/100),Fit(0,MaxDAValue,Value10*MaxDAValue/100)), extcomm
end

;Set Events for init times
;Event00......event value Lo for Start Event
;Event0......event value Lo for Start+1 Event
;Time00......Time value in sec  for Start Event, minimal duration 10msec
;Time0......Time value in sec for Start+1 Event,minimal duration 10msec
;event values:
;1.........A1
;2.........A2
;4.........A3 (IR)
;8.........A4
;16........A5
;32........A6 (Stirrer)
Action Init_AUX(Event00,Time00,Event0,Time0) begin            ;!!!!!!!! USE ONLY IN INIT TIMES !!!!!!
<0s>=>__Init_AUX(Event00,Event0,Fit(1,32000,Time00*100),Fit(0,32000,Time0*100)), extcomm
end


;Freeze the device for defined time in seconds (10ms minimal step, maximum 650s)
;Value1....time in seconds rounded to 10ms
;Value2....use this command in all repeats = 1; use only in first run = 0;
Action Freeze(Value1,Value2) begin
  <0s>=>__Freeze(Value1*100,Value2), extcomm
end
;



