
CompAction __StartReg(v: byte) begin
 0xB0, v
end

CompAction __StopReg begin
 0xB1 
end

CompAction __SetTemp(v: int) begin
 0xB3, v
end

CompAction __SetRisTemp(v: int, z:word) begin
 0xB4, v, z 
end

CompAction __SetRegulator(v: byte, z:byte) begin
 0xB7, v, z 
end


PrimAction	m1int(0x0001,0x10000001,sample_duration)		; Integration AD converter - Bit 0
PrimAction      m2temp(0x0002,0x10000002,10us)				; Thermoregulator - Bit 1


;Temperature regulation start
Action StartReg begin
 <0>=>__StartReg(1), extcomm
end

;Temperature regulation stop
Action StopReg begin
 <0>=>__StopReg, extcomm
end


;Set regulation temperature for TR2000
;parameter: 	- temperature in 1C (0-100)
Action SetTemp(Value) begin
  <0>=>__SetTemp(Value), extcomm
end



;Set parameters of rising mode for TR2000
;parameters: 	Value  - demanded regulation end temperature in 1C (0-100)
;		Value2 - time for reaching the temperature in sec (65535)	
Action SetRisTemp(Value, Value2) begin
  <0>=>__SetRisTemp(Fit(-24,70,Value), Value2), extcomm
end


;Set Regulator constants
;parameters:    Value - Sum_term  - 1 byte size only 
;		Value2 - Gain_term - 1 byte size only
Action SetRegulator(Value, Value2) begin
  <0>=>__SetRegulator(Value, Value2), extcomm
end
;

;Set Regulator constants for new versions of TR2000 (> 2.3.0.1)
;parameters:    Value - Sum_term  
;		Value2 - Gain_term
Action SetRegulator_I_K(Value, Value2) begin
  Value_Hi = Value/256.0
  Value2_Hi = Value2/256.0
  <0>=>__ChanI2C_4(2,136,76,73,Value,Value_Hi), extcomm       ;LI
  <0>=>__ChanI2C_4(2,136,76,75,Value2,Value2_Hi), extcomm       ;LK
end
;

;Set Regulator constants
;parameters:    Value - Maximal Heating limit (0 - 100%)  
;(2,0x88,'LM',Value)
Action MaxHeating(Value) begin
  ValFit = Fit(0,100,Value)
  <0>=>__ChanI2C_4(2,136,76,77,ValFit,0), extcomm
end

;Set Regulator constants
;parameters:    Value - Antiwindup 
;(2,0x88,'LA',Value)
Action AntiWindup(Value) begin
  Value_Hi = Value / 256.0
  <0>=>__ChanI2C_4(2,136,76,65,Value,Value_Hi), extcomm
end

;Set Regulator constants
;parameters:    Value - K_correction x 10
;(2,0x88,'LT',Value)
Action K_correction(Value) begin
  Value_Hi = Value / 256.0
  <0>=>__ChanI2C_4(2,136,76,84,Value,Value_Hi), extcomm
end

;Set Regulator constants
;parameters:    Value - desired value digital output 
;(2,0x88,'LC',Value)
Action Digital_Output_type(Value) begin
  Value_Hi = Value / 256.0
  <0>=>__ChanI2C_4(2,136,76,67,Value,Value_Hi), extcomm
end

